#include "genesis.h"
#include "string.h"

#include "libres.h"	// 摜\[Xp

#include "psgd.h"

#define JOY_TYPE_KABUTOGANI_ANALOG 0x07
#define LIGHT 1
#define DARK  0

// O[oϐ
static u16 shotCount[2][10];	// ߋ10bԂ̘Aːz(1vf1bj
static u8  shotCountIdx;		// Oobt@CfbNX
static u16 bestRFS[2];			// ÑxXgAːishotCount10vfvj

static u8  vBlankCount;			// VBlankJEg

static u8  hIntCounterToFire;	// JE^𒴂Cxg
static u8  hIntEventFired;		// Cxg{ς݃tO
static u8  hIntPerScan;			// setHIntCounterɎgl
static u16 hBlankCount;			// HBlankJEg
static u8  valPort2Sel;			// WCXeBbN|[g2SELMH/L
static char str[2][64];

static u16 currentType[2];		// ݂̃WCXeBbN
static u16 currentValue[2];		// ݂̃WCXeBbN{^ǂݎl
static s16 currentADVal[2][4];	// ݂̃AiOǂݎl

static u8  TurboMode;			// TURBO[hiJugKjǂݎ肵ȂA0.5t[WCXeBbNǂ)

// 萔

// ֐錾
static void VIntMethod();
static void HIntMethod();
static void RenewJoypad();
static void InitTestView();
static void GetAttrDatasForString(char *, int, u16 *, u16);
static void PutString_withPal(char *, u16, u8, u8);
static void RenewTestView();
static void RenewTestView_Sub_Detected();
static void RenewTestView_Sub_Buttons();
static void RenewTestView_Sub_AnalogVal();
static void RenewTestView_Sub_Rapid();
static void RenewTestView_Sub_Castle();
static void SetCastleColor(u8);
static u8   CheckTurboMode();

// t@CO̊֐
extern void My_JOY_init();
extern void My_JOY_update();
extern s16  JOY_readJoypadT(u16 joy);
extern s16  JOY_readJoypadO(u16 joy);
extern void JOY_SetTurboMode(u8 mode);

// t@CÕf[^
extern u8 songData_Jump[];
extern u8 songData_Bubble[];

int main()
{
    //u8 value;
	u16 i;

	// O[oϐ
	shotCountIdx = 0;
	for(i = 0; i < 10; i++)
	{
		shotCount[0][i] = 0;
		shotCount[1][i] = 0;
	}
	vBlankCount = 0;
	bestRFS[0] = 0;
	bestRFS[1] = 0;

	currentType[0] = 0xffff;
	currentType[1] = 0xffff;
	currentValue[0] = 0xffff;
	currentValue[1] = 0xffff;
	for(i = 0; i < 4; i++)
	{
		currentADVal[0][i] = 0;
		currentADVal[1][i] = 0;
	}

	hBlankCount = 0;
	hIntCounterToFire = 46;		// 46őOK
	valPort2Sel = 0;
	hIntPerScan = 1;
	hIntEventFired = 0;
	
	TurboMode = 0;
	
	// 
	// VDP֘Ȁ
	// 
    VDP_setScreenWidth320();
    VDP_setHInterrupt(1);				// HInterrupt ON
    VDP_setHIntCounter(hIntPerScan);	// HInterrupt𑖍{ɔ邩i0ŖXLCj
    VDP_setHilightShadow(0);			// nCCgEVhE@\ 1:ON, 0:OFF

    VDP_setTextPalette(1);
    VDP_setPaletteColor( 0+16, 0x0e75);	// wiF
    VDP_setPaletteColor(14+16, 0x0000);	// pbg1 color#14
    VDP_setPaletteColor(15+16, 0x0aee);	// pbg1 color#15		// F 0x0eeeŃ}XNB0BGȐ
	//VDP_setScrollingMode(HSCROLL_LINE, VSCROLL_2TILE);	// XN[[hݒ
	
	// tHgǂݍ
	VDP_loadFont(&user_font, 1);

	// wip^[̃pbgǂݍ݂ƕ\
	//VDP_setPalette(0, image_castle.palette->data);	//pbg̐ݒ
	VDP_drawImageEx(PLAN_B, &image_castle, TILE_ATTR_FULL(PAL0, 0, 0, 0, TILE_USERINDEX), 0, 0, 0, 1);
	//SetCastleColor(LIGHT);
	SetCastleColor(DARK);

	//
	// WCXeBbN֘Ȁ
	//
	My_JOY_init();

	// VBlank荞
	SYS_setVIntCallback(VIntMethod);
	SYS_setHIntCallback(HIntMethod);

	//	for (i = 0; i < 39; i++) VDP_setTileMapXY(PLAN_A, TILE_FONTINDEX + i, i, 1);


	// Turbo
	TurboMode = CheckTurboMode();
	JOY_SetTurboMode(TurboMode);
	if(!TurboMode)
	{
	    VDP_setHInterrupt(0);				// HInterrupt OFF
	}

	// eXgʂ̏\
	InitTestView();

	// TEhhCo
	PSGD_Init();
	PSGD_SetData(0, songData_Jump);
	PSGD_SetData(1, songData_Bubble);

	// iv[v
    while(1)
    {
		// \XV
		RenewTestView();

        VDP_waitVSync();
    }
}

static void SetCastleColor(u8 type)
{
	// PAL0ŕ\Ă
	
	if(type)
	{
		// 邢Fɂ
		VDP_setPalette(0, user_palette.data);
	}
	else
	{
		// ÂFɂ
		VDP_setPalette(0, image_castle.palette->data);
	}
}

static void GetAttrDatasForString(char *str, int strLen, u16 *attr, u16 palNum)
{
	int i;
	for (i = 0; i < strLen; i++) 
	{
		attr[i] = TILE_ATTR_FULL(palNum, 1, 0, 0, TILE_FONTINDEX + str[i] - 0x20);
	}
}

static void PutString_withPal(char *str, u16 palNum, u8 x, u8 y)
{
	u16	attr[64];
	int	len;
	
	len = strlen(str);
	if(len > 64)
	{
		len = 64;
	}
	
	GetAttrDatasForString(str, len, attr, palNum);
	VDP_setTileMapData(VDP_PLAN_A, attr, x + y * 0x40, len, /*TRUE*/FALSE);
//	VDP_setTileMapData(VDP_PLAN_A, attr, x + y * 0x40, len, TRUE);
}

//
// WCXeBbNeXgʂ
//
static void InitTestView()
{
	int		i;
	u16		attr[64];

	// S̃NApbgݒ
	//		1s̃f[^
	for (i = 0; i < 64; i++) 
	{
		attr[i] = TILE_ATTR_FULL(PAL1, 1, 0, 0, TILE_FONTINDEX + 0x00);
	}
	//		SsɃZbg
	for (i = 0; i < 28; i++)
	{
		VDP_setTileMapData(VDP_PLAN_A, attr, i * 0x40, 64 / sizeof(u16), TRUE);	
		
	}
	
	// ʕ\
	if(TurboMode)
	{
		PutString_withPal("JOYSTICK TEST  -TURBO MODE-",      PAL1,  2, 1);
		PutString_withPal("PORT1", PAL1, 13, 3);
	}
	else
	{
		PutString_withPal("JOYSTICK TEST",      PAL1,  2, 1);
		PutString_withPal("PORT1        PORT2", PAL1, 13, 3);
	}


	PutString_withPal("DETECTED :",         PAL1, 2,  5);

	PutString_withPal("BUTTONS  :",         PAL1, 2,  7);

	PutString_withPal("ANALOG  X:",      PAL1, 2, 10);
	PutString_withPal("VALUES  Y:",      PAL1, 2, 11);
	PutString_withPal("        T:",      PAL1, 2, 12);
	PutString_withPal("        O:",      PAL1, 2, 13);

	PutString_withPal("RAPID FIRE SPEED",   PAL1, 2, 15);

	PutString_withPal("#OF SHOTS:",      PAL1, 2, 17);
	PutString_withPal("IN THE",          PAL1, 2, 18);
	PutString_withPal("PAST 10 SEC",       PAL1, 2, 19);

	PutString_withPal("SHOTS/SEC",  PAL1, 2, 21);
	PutString_withPal("CURRENT  :", PAL1, 2, 22);
	PutString_withPal("BEST     :", PAL1, 2, 23);
}

//
// WCXeBbNeXgʂXV Tu F
//
static void RenewTestView_Sub_Detected()
{
	u16    type;
	int    i;
	
	if(TurboMode == 1)
	{
		return;
	}
	else
	{
		for(i = 0; i < ((TurboMode) ? 1 : 2); i++)
		{
			str[i][0] = 0;
			type = JOY_getJoypadType(i);

			if(type != currentType[i])
			{
				// ʂςʍXV
		        switch (type)
		        {
		            case JOY_TYPE_PAD3:
		                sprintf(&str[i][0], "3 BUTTON  ");
		                break;
		            case JOY_TYPE_PAD6:
		                sprintf(&str[i][0], "6 BUTTON  ");
		                break;
		            case JOY_TYPE_TRACKBALL:
		                sprintf(&str[i][0], "TRACKBALL ");
		                break;
		            case JOY_TYPE_MOUSE:
		                sprintf(&str[i][0], "MOUSE     ");
		                break;
		            case JOY_TYPE_MENACER:
		                sprintf(&str[i][0], "MENACER   ");
		                break;
		            case JOY_TYPE_JUSTIFIER:
		                sprintf(&str[i][0], "JUSTIFIER ");
		                break;
		            case JOY_TYPE_PHASER:
		                sprintf(&str[i][0], "PHASER    ");
		                break;
		            case JOY_TYPE_KABUTOGANI_ANALOG:
		                sprintf(&str[i][0], "KABUTOGANI");
		                break;
		            default:
		                sprintf(&str[i][0], "UNKNOWN   ");
		                break;
		        }
			}
			
		}
	}

	PutString_withPal(&str[0][0],     PAL1, 13,  5);
	PutString_withPal(&str[1][0],     PAL1, 26,  5);
}

//
// WCXeBbNeXgʂXV Tu {^
//
static void RenewTestView_Sub_Buttons()
{
	u16  type, value;
	int  i;
	char tmpstr[64];

	for(i = 0; i < ((TurboMode) ? 1 : 2); i++)
	{
		str[i][0] = 0;
		tmpstr[0] = 0;
		type = JOY_getJoypadType(i);
        value = JOY_readJoypad(i);

		if(
			type != currentType[i] ||
			value != currentValue[i] 
		)
		{
			// ʂ̓{^񂪕ςƂ̂݉ʍXV
	        switch (type)
	        {
	            case JOY_TYPE_PAD3:
	            case JOY_TYPE_PAD6:
	                strcat(tmpstr, (value & BUTTON_UP) ? "U" : "-");
	                strcat(tmpstr, (value & BUTTON_DOWN) ? "D" : "-");
	                strcat(tmpstr, (value & BUTTON_LEFT) ? "L" : "-");
	                strcat(tmpstr, (value & BUTTON_RIGHT) ? "R" : "-");
	                strcat(tmpstr, (value & BUTTON_A) ? "A" : "-");
	                strcat(tmpstr, (value & BUTTON_B) ? "B" : "-");
	                strcat(tmpstr, (value & BUTTON_C) ? "C" : "-");
	                strcat(tmpstr, (value & BUTTON_START) ? "S" : "-");
	                
	                if(type == JOY_TYPE_PAD6)
	                {
		                strcat(tmpstr, (value & BUTTON_X)    ? "X" : "-");
		                strcat(tmpstr, (value & BUTTON_Y)    ? "Y" : "-");
		                strcat(tmpstr, (value & BUTTON_Z)    ? "Z" : "-");
		                strcat(tmpstr, (value & BUTTON_MODE) ? "M" : "-");
					}
					else
					{
		                strcat(tmpstr, "    ");
					}
					PutString_withPal(tmpstr,         PAL1, 13 + i * 13,  7);
					PutString_withPal("            ", PAL1, 13 + i * 13,  8);
					
	                break;
	            case JOY_TYPE_KABUTOGANI_ANALOG:
	            	// 1s
	                sprintf(tmpstr, (value & 0x0080) ? "A" :  "-");
	                strcat(tmpstr,  (value & 0x0040) ? "B" :  "-");
	                strcat(tmpstr,  (value & 0x0020) ? "C" :  "-");
	                strcat(tmpstr,  (value & 0x0010) ? "D" :  "-");
	                strcat(tmpstr,  (value & 0x0008) ? "E1" : "- ");
	                strcat(tmpstr,  (value & 0x0004) ? "E2" : "- ");
	                strcat(tmpstr, "    ");
					PutString_withPal(tmpstr,         PAL1, 13 + i * 13,  7);

	                sprintf(tmpstr, (value & 0x0002) ? "St" : "- ");
	                strcat(tmpstr,  (value & 0x0001) ? "Sl" : "- ");
	                strcat(tmpstr,  (value & 0x0200) ? "A'" : "- ");
	                strcat(tmpstr,  (value & 0x0100) ? "B'" : "- ");
	                strcat(tmpstr, "    ");
					PutString_withPal(tmpstr,         PAL1, 13 + i * 13,  8);
	                break;
	            default:
					PutString_withPal("            ", PAL1, 13 + i * 13,  7);
					PutString_withPal("            ", PAL1, 13 + i * 13,  8);
	                break;
	        }

			//strcpy(&str[i][0], tmpstr);
			
		}

	}
}

//
// WCXeBbNeXgʂXV Tu AiOl
//
static void RenewTestView_Sub_AnalogVal()
{
	u16  type;
	s16  x, y, t, o;
	int  i;
	char tmpstr[64];

	for(i = 0; i < ((TurboMode) ? 1 : 2); i++)
	{
		str[i][0] = 0;
		tmpstr[0] = 0;
		type = JOY_getJoypadType(i);
		x = JOY_readJoypadX(i);
		y = JOY_readJoypadY(i);
		t = JOY_readJoypadT(i);
		o = JOY_readJoypadO(i);
		
		if(
			type != currentType[i] ||
			x != currentADVal[i][0] ||
			y != currentADVal[i][1] ||
			t != currentADVal[i][2] ||
			o != currentADVal[i][3] 
		)
		{
			// ʂ̓{^񂪕ςƂ̂݉ʍXV
	        switch (type)
	        {
	            case JOY_TYPE_KABUTOGANI_ANALOG:
		            sprintf(tmpstr, "%02X", x);
					PutString_withPal(tmpstr, PAL1, 13 + i * 13, 10);

		            sprintf(tmpstr, "%02X", y);
					PutString_withPal(tmpstr, PAL1, 13 + i * 13, 11);

		            sprintf(tmpstr, "%02X", t);
					PutString_withPal(tmpstr, PAL1, 13 + i * 13, 12);

		            sprintf(tmpstr, "%02X", o);
					PutString_withPal(tmpstr, PAL1, 13 + i * 13, 13);
	                break;
	            default:
					PutString_withPal("  ", PAL1, 13 + i * 13, 10);
					PutString_withPal("  ", PAL1, 13 + i * 13, 11);
					PutString_withPal("  ", PAL1, 13 + i * 13, 12);
					PutString_withPal("  ", PAL1, 13 + i * 13, 13);
	                break;
	        }
		}


	}

}

//
// WCXeBbNeXgʂXV Tu Aˊ֌W
//
static void RenewTestView_Sub_Rapid()
{
    u16  shot10sec = 0;
	int  i, j;
	char tmpstr[64];

	for(i = 0; i < ((TurboMode) ? 1 : 2); i++)
	{
		shot10sec = 0;
		// ߋ10bԂ̃gK{^
	    for(j = 0; j < 10; j++)
	    {
			shot10sec += shotCount[i][j];
		}
		
		// xXgXV
		if(bestRFS[i] < shot10sec)
		{
			bestRFS[i] = shot10sec;
		}
		
		sprintf(tmpstr, "%03d", shot10sec);
		PutString_withPal(tmpstr, PAL1, 13 + i * 13, 17);

		// Jg[/b]\
		sprintf(tmpstr, "%02d.%d", 
			shot10sec / 10,
			shot10sec % 10);
		PutString_withPal(tmpstr, PAL1, 13 + i * 13, 22);
		// xXgl[/b]\
		sprintf(tmpstr, "%02d.%d", 
			bestRFS[i] / 10,
			bestRFS[i] % 10);
		PutString_withPal(tmpstr, PAL1, 13 + i * 13, 23);
	}
}



//
// WCXeBbNeXgʂXV Tu ֌W
//
static void RenewTestView_Sub_Castle()
{

}


///
/// WCXeBbNeXgʂXV
///
static void RenewTestView()
{
	int i;
	
    // disable ints
    SYS_disableInts();

	RenewTestView_Sub_Detected();
	RenewTestView_Sub_Buttons();
	RenewTestView_Sub_AnalogVal();
	RenewTestView_Sub_Rapid();
	RenewTestView_Sub_Castle();
	
    // restore ints
    SYS_enableInts();

	// current`͂ňꊇXV
	for(i=0; i< 2; i++)
	{
		currentType[i]  = JOY_getJoypadType(i);
		currentValue[i] = JOY_readJoypad(i);
		currentADVal[i][0] = JOY_readJoypadX(i);
		currentADVal[i][1] = JOY_readJoypadY(i);
		currentADVal[i][2] = JOY_readJoypadT(i);
		currentADVal[i][3] = JOY_readJoypadO(i);
	}
	
}




//
//
// V-Blank荞݂ŌĂяo鏈
//
//
static void VIntMethod()
{
	// WCXeBbNXV
	RenewJoypad();
	
	// HBlank荞ݏɊւϐ
	hBlankCount = 0;
	hIntEventFired = 0;
	
	// Oobt@CfbNXړ
	vBlankCount++;
	if(IS_PALSYSTEM)
	{
		if(vBlankCount > 50)
		{
			vBlankCount = 0;
			shotCountIdx++;
			if(shotCountIdx == 10)
			{
				shotCountIdx = 0;
			}
			
			// ړvfNA
			shotCount[0][shotCountIdx] = 0;
			shotCount[1][shotCountIdx] = 0;
		}
	}
	else
	{
		if(vBlankCount > 60)
		{
			vBlankCount = 0;
			shotCountIdx++;
			if(shotCountIdx == 10)
			{
				shotCountIdx = 0;
			}
			
			// ړvfNA
			shotCount[0][shotCountIdx] = 0;
			shotCount[1][shotCountIdx] = 0;
		}
	}

	// TEhhCo
	PSGD_PeriodicProc();

}



//
//
// H-Blank荞݂ŌĂяo鏈
//
//
static void HIntMethod()
{
	if(hIntEventFired == 0)
	{
		hBlankCount+=hIntPerScan;
		
		if(hBlankCount > hIntCounterToFire)
		{
			// WCXeBbNXV
			RenewJoypad();
			hBlankCount = 0;
			hIntEventFired = 1;
		}
	}
	
}



//
// WCXeBbNXV
//
static void RenewJoypad()
{
	u16 i, type, btnState_old[2], btnState_new[2];
	u16 nowPressedButtons;	// AĂ{^
	
	// Â{^ۑ
	btnState_old[0] = JOY_readJoypad(0);
	btnState_old[1] = JOY_readJoypad(1);
	
	// WCpbhǂݎ
	My_JOY_update();
	
	for(i = 0; i < ((TurboMode) ? 1 : 2); i++)
	{
		// V{^ۑ
		btnState_new[i] = JOY_readJoypad(i);
		
		// nowPressedButtons}XNOɕۑ
		nowPressedButtons = btnState_new[i];
		
		// gK[ȊÕ{^rbg}XN
		type = JOY_getJoypadType(i);
		if(type == JOY_TYPE_PAD3 || type == JOY_TYPE_PAD6)
		{
			btnState_old[i] = btnState_old[i] & 0x0ff0;
			btnState_new[i] = btnState_new[i] & 0x0ff0;
		}
		else if(type == JOY_TYPE_KABUTOGANI_ANALOG)
		{
			btnState_old[i] = btnState_old[i] & 0x03ff;
			btnState_new[i] = btnState_new[i] & 0x03ff;
		}
		
		// ݉Ă{^Ώۂ
		// {^ԂɍAOobt@vf+1
		if((nowPressedButtons & (btnState_old[i] ^ btnState_new[i])) != 0)
		{
			shotCount[i][shotCountIdx] = shotCount[i][shotCountIdx] + 1;
			
			PSGD_Play(i);
		}
	}
	
	/*
	// Port2SELMグ
	ChangeJoyPortSel(PORT_2, valPort2Sel);
	valPort2Sel = ~valPort2Sel;
	*/
}

//
// Turbo[h
//
static u8   CheckTurboMode()
{
	u16 btnState;

	// @6Bgpɂ`abNŁA3{^ɌF錻ۑ΍
	VDP_waitVSync();
	VDP_waitVSync();
	VDP_waitVSync();
	
	btnState = JOY_readJoypad(0);
	
	if(
		(btnState & BUTTON_A) != 0 &&
		(btnState & BUTTON_B) != 0 &&
		(btnState & BUTTON_C) != 0 
	)
	{
		return 1;
	}
	
	return 0;
}


